"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-magic-numbers */
const os_1 = require("os");
const global_1 = __importDefault(require("./global"));
exports.setupGlobal = () => {
    global_1.default.mockStdout = {
        write: jest.fn(),
    };
    process.stdout.write = global_1.default.mockStdout.write;
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const converter = (prefix = '') => (value) => process.stdout.write(prefix + JSON.stringify(value, null, '\t') + os_1.EOL);
    console.log = jest.fn(converter());
    console.info = jest.fn(converter('__info__'));
    console.error = jest.fn(converter('__error__'));
    console.warn = jest.fn(converter('__warning__'));
    global_1.default.mockChildProcess = {
        stdout: 'stdout',
        stderr: '',
        error: null,
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        exec: jest.fn((...args) => {
            const callback = args.length === 2 ? args[1] : args[2];
            callback(typeof global_1.default.mockChildProcess.error === 'function' ? global_1.default.mockChildProcess.error(args[0]) : global_1.default.mockChildProcess.error, typeof global_1.default.mockChildProcess.stdout === 'function' ? global_1.default.mockChildProcess.stdout(args[0]) : global_1.default.mockChildProcess.stdout, typeof global_1.default.mockChildProcess.stderr === 'function' ? global_1.default.mockChildProcess.stderr(args[0]) : global_1.default.mockChildProcess.stderr);
        }),
    };
    jest.mock('child_process', () => (Object.assign(Object.assign({}, jest.requireActual('child_process')), { exec: global_1.default.mockChildProcess.exec })));
    process.env.GITHUB_ACTOR = 'octocat';
};
